"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPlural = getPlural;
exports.getAllPlurals = getAllPlurals;
exports.hasPlural = hasPlural;

var Cardinals = _interopRequireWildcard(require("make-plural/cardinals"));

var PluralCategories = _interopRequireWildcard(require("make-plural/pluralCategories"));

var Plurals = _interopRequireWildcard(require("make-plural/plurals"));

var _safeIdentifier = require("safe-identifier");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function normalize(locale) {
  if (typeof locale !== 'string' || locale.length < 2) throw new RangeError(`Invalid language tag: ${locale}`); // The only locale for which anything but the primary subtag matters is
  // Portuguese as spoken in Portugal.

  if (locale.startsWith('pt-PT')) return 'pt-PT';
  const m = locale.match(/.+?(?=[-_])/);
  return m ? m[0] : locale;
}

function getPlural(locale) {
  if (typeof locale === 'function') {
    const lc = normalize(locale.name);
    return {
      isDefault: false,
      id: (0, _safeIdentifier.identifier)(lc),
      lc,
      locale: locale.name,
      getPlural: locale,
      cardinals: locale.cardinals || [],
      ordinals: locale.ordinals || []
    };
  }

  const lc = normalize(locale);

  if (lc in Plurals) {
    return {
      isDefault: true,
      id: (0, _safeIdentifier.identifier)(lc),
      lc,
      locale,
      getCardinal: Cardinals[lc],
      getPlural: Plurals[lc],
      cardinals: PluralCategories[lc].cardinal,
      ordinals: PluralCategories[lc].ordinal
    };
  }

  return null;
}

function getAllPlurals(firstLocale) {
  const keys = Object.keys(Plurals).filter(key => key !== firstLocale);
  keys.unshift(firstLocale);
  return keys.map(getPlural);
}

function hasPlural(locale) {
  const lc = normalize(locale);
  return lc in Plurals;
}